<script setup lang="ts">
import type { Stock } from '@/types/Stock'
import { nextTick, onMounted, provide, ref } from 'vue'

import SProductDialog from './SProductDialog.vue'
import StockProductTableDetail from './StockProductTableDetail.vue'
import CheckStockDialog from './CheckStockDialog.vue'
import ImportDialog from './ImportDialog.vue'
import ShowReceiptDialog from './ShowReceiptDialog.vue'
import { useCheckStockStore } from '@/stores/checkstock'
import { useStockStore } from '@/stores/stock'
import CheckStockHistoryDialog from './CheckStockHistoryDialog.vue'
import { usePermissionStore } from '@/stores/permission'
import { useAuthStore } from '@/stores/auth'
const permissionStore = usePermissionStore()
const stockStore = useStockStore()
const checkStockStore = useCheckStockStore()
// const stockItem:Stock[] = [
// { id: 1, name: 'ไซรัป', minimum: 10, balance:15,unit:'ขวด', price:225},
// { id: 2, name: 'เมล็ดกาแฟ', minimum: 10, balance:4,unit:'กิโลกรัม', price:400},
// { id: 3, name: 'ผงชาไทย', minimum: 10, balance:6,unit:'กิโลกรัม', price:300},
// { id: 4, name: 'ผงโกโก้', minimum: 10, balance:5,unit:'กิโลกรัม', price:350},
// { id: 5, name: 'ผงชาเขียว', minimum: 10, balance:8,unit:'กิโลกรัม', price:360},
// { id: 6, name: 'นมจืด', minimum: 10, balance:3,unit:'กิโลกรัม', price:120},
// { id: 7, name: 'น้ำเชื่อม', minimum: 10, balance:8,unit:'ลิตร', price:250},
// { id: 8, name: 'วิปปิ่งครีม', minimum: 10, balance:11,unit:'ลิตร', price:150},
// { id: 9, name: 'น้ำผึ้ง', minimum: 10, balance:14,unit:'ลิตร', price:95},
// { id: 10, name: 'ครีมเทียม', minimum: 10, balance:12,unit:'ลิตร', price:120},
// { id: 11, name: 'น้ำตาลคาราเมล', minimum: 10, balance:4,unit:'กิโลกรัม', price:120},
// { id: 12, name: 'ไข่มุก', minimum: 10, balance:6,unit:'กิโลกรัม', price:35},
// { id: 13, name: 'เมล็ดมะขามคั่ว', minimum: 10, balance:10,unit:'กิโลกรัม', price:250},
// { id: 14, name: 'กีวี', minimum: 10, balance:11,unit:'กิโลกรัม', price:150},
// ]

const search = ref('')
const loading = ref(false)
function openShowReceipt() {
  stockStore.dialogShowReceipt = !stockStore.dialogShowReceipt
}

const authStore = useAuthStore()
const isRole = ref()
function whatRole(){
  if(authStore.getCurrentUser()?.role =='Staff' || authStore.getCurrentUser()?.role =='Manager' ){
    isRole.value = true
  }
  if(authStore.getCurrentUser()?.role =='Owner'){
    isRole.value = true
  }
}
onMounted(async () => {
  if (!permissionStore.isEmp()) {
    permissionStore.pushMember()
  }
  whatRole()
  console.log("Role"+ authStore.getCurrentUser()?.role!);
  
})
</script>
<template>
  <v-toolbar flat style="background-color: #212121; color: white">
      <v-toolbar-title>Stock Management</v-toolbar-title>
      <!-- <v-text-field
        v-model="stockStore.search"
        density="compact"
        variant="solo"
        label="Search Product"
        append-inner-icon="mdi-magnify"
        single-line
        hide-details
        style="width: 200px"
      >
      </v-text-field> -->
      <div>
          <v-btn
            prepend-icon="mdi-plus"
            style="margin-right: 20px; background-color: #c7a17a; color: white; margin-bottom: 0px;"
            @click="stockStore.openAddDialog"
            >Meterial Add</v-btn
          >
        </div>
    </v-toolbar>
  <v-container style="width: 90%; max-width: none;">
    <v-row no-gutters>
      
      <!-- <v-col>
        <h1 style="font-size: 70px; margin-left: 10px;">Stock</h1>
      </v-col>
      <v-col >
        <v-text-field
          v-model="stockStore.search"
          density="compact"
          variant="solo"
          label="Search Stock Item"
          append-inner-icon="mdi-magnify"
          single-line
          hide-details
          style="width: 200px; padding-top: 90px; margin-top: 0px;"
        >
        </v-text-field>
      </v-col> -->
      <!-- <v-col > -->
        <!-- <div>
          <v-btn
            prepend-icon="mdi-plus"
            style="margin-left: 1450px; background-color: #47bb59; color: white; margin-bottom: 20px;"
            @click="stockStore.openAddDialog"
            >Meterial Add</v-btn
          >
        </div> -->
      <!-- </v-col> -->
          <!-- 3 BTN  -->
            <v-col cols="12" md="3" style="padding-top: 100px">
              <div>
                <v-btn
                  prepend-icon="mdi-receipt-text"
                  style="margin-left: 1070px"
                  @click="openShowReceipt()"
                  >Receipt</v-btn
                >
              </div></v-col
            >
            <v-col cols="12" md="3" style="padding-top: 100px">
              <div>
                <v-btn
                  prepend-icon="mdi-file-import"
                  style="margin-left: 525px; background-color: #0d47a1; color: white"
                  @click="stockStore.openImportDialog"
                  >Import</v-btn
                >
              </div></v-col
            >
            <v-col cols="12" md="3" style="padding-top: 100px"
              ><div>
                <v-btn
                  @click="stockStore.openCheckDialog"
                  prepend-icon="mdi-package-variant-closed-check"
                  style="margin-left: 400px; background-color: #ffca28"
                  >Check Stock</v-btn
                >
              </div></v-col
            >
            <v-col cols="12" md="3" style="padding-top: 100px">
              <div>
                <v-btn
                  prepend-icon="mdi-history"
                  style="margin-left: 170px"
                  @click="checkStockStore.dialogHistory = true"
                >
                  Check Stock History</v-btn
                >
              </div></v-col
            >
          </v-row>
       

    <v-row no-gutters>
      <!-- <v-sheet
        width= "90%"
        height="500"
        style="background-color: #e7d0b9; border: rgb(112, 73, 31) solid 2px"
        
      > -->
        <stock-product-table-detail ></stock-product-table-detail>
        <!-- <stock-product-table-detail-owner v-if="authStore.getCurrentUser()?.role! =='Owner'"></stock-product-table-detail-owner> -->
        <v-row no-gutters>
          <!-- 3 BTN  -->
          <!-- <v-row no-gutters>
            <v-col cols="12" md="3" style="padding-top: 0px">
              <div>
                <v-btn
                  prepend-icon="mdi-receipt-text"
                  style="margin-left: 550px"
                  @click="openShowReceipt()"
                  >Receipt</v-btn
                >
              </div></v-col
            >
            <v-col cols="12" md="3" style="padding-top: 0px">
              <div>
                <v-btn
                  prepend-icon="mdi-file-import"
                  style="margin-left: 95px; background-color: #0d47a1; color: white"
                  @click="stockStore.openImportDialog"
                  >Import</v-btn
                >
              </div></v-col
            >
            <v-col cols="12" md="3" style="padding-top: 0px"
              ><div>
                <v-btn
                  @click="stockStore.openCheckDialog"
                  prepend-icon="mdi-package-variant-closed-check"
                  style="margin-left: 120px; background-color: #ffca28"
                  >Check Stock</v-btn
                >
              </div></v-col
            >
            <v-col cols="12" md="3" style="padding-top: 0px">
              <div>
                <v-btn
                  prepend-icon="mdi-history"
                  style="margin-left: 10px"
                  @click="checkStockStore.dialogHistory = true"
                >
                  Check Stock History</v-btn
                >
              </div></v-col
            >
          </v-row> -->
        </v-row>
      <!-- </v-sheet> -->
    </v-row>
  </v-container>
  <s-product-dialog  ></s-product-dialog>
  <check-stock-dialog></check-stock-dialog>
  <import-dialog></import-dialog>
  <show-receipt-dialog></show-receipt-dialog>
  <check-stock-history-dialog></check-stock-history-dialog>
</template>
<style>
    tbody tr:nth-of-type(even) {
  background-color: #dddcde;
}

tbody tr:nth-of-type(odd) {
  background-color: #f5f4f7;
}

thead {
  background-color: #403c3c;
  color: rgb(0, 0, 0);
  font-weight: bold;
  color: white;
}

.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
